diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/AUTHORS ns-3.38/AUTHORS
--- ns-3.37/AUTHORS	2022-11-01 17:37:24.359394800 -0700
+++ ns-3.38/AUTHORS	2023-03-16 20:54:23.484868000 -0700
@@ -72,6 +72,7 @@
 Christoph Döpmann (doepmanc@informatik.hu-berlin.de)
 Jordan Dorham (dorham1@llnl.gov)
 Craig Dowell (craigdo@ee.washington.edu)
+Matteo Drago (matteo.drago1994@gmail.com)
 Gilaras Drakeson (gilaras@gmail.com)
 Jared Dulmage (jared.dulmage@wpli.net)
 Mathias Ettinger (mettinger@toulouse.viveris.com)
@@ -209,13 +210,13 @@
 Anh Nguyen (annguyen@ittc.ku.edu)
 Duy Nguyen (duy@soe.ucsc.edu)
 Alfonso Oliveira (af.oliveira.16@gmail.com)
+Wouter Overmeire (lodagro@gmail.com)
 Luis Pacheco (luisbelem@gmail.com)
+Matteo Pagin (mattpagg@gmail.com)
 Jendaipou Palmei (jendaipoupalmei@gmail.com)
-Lluís Parcerisa (parcerisa@gmail.com)
 Parth Pandya (parthpandyappp@gmail.com)
+Lluís Parcerisa (parcerisa@gmail.com)
 Mingyu Park (darkpmg@naver.com)
-Jendaipou Palmei (jendaipoupalmei@gmail.com)
-Parth Pandya (parthpandyappp@gmail.com)
 Harsh Patel (thadodaharsh10@gmail.com)
 Natale Patriciello (natale.patriciello@gmail.com)
 Pavinberg (pavin0702@gmail.com)
@@ -295,10 +296,11 @@
 Dave Taht (dave.taht@bufferbloat.net)
 Marcos Talau (talau@users.sourceforge.net)
 Adrian S. W. Tam (adrian.sw.tam@gmail.com)
+Bill Tao (toyjet8@gmail.com)
 Cristiano Tapparello (cristiano.tapparello@rochester.edu)
 Hajime Tazaki (tazaki@sfc.wide.ad.jp)
 Wilson Thong (wilsonwk@ee.cityu.edu.hk)
-Lars Toenning (lars.toenning@gmail.com)
+Lars Toenning (dev@ltoenning.de)
 Omer Topal (omer.topal@airties.com)
 Mauro Tortonesi (mauro.tortonesi@unife.it)
 Quincy Tse (quincy.tse@gmail.com)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/bindings/python/ns__init__.py ns-3.38/bindings/python/ns__init__.py
--- ns-3.37/bindings/python/ns__init__.py	2022-11-01 17:37:24.367394700 -0700
+++ ns-3.38/bindings/python/ns__init__.py	2023-03-16 20:54:23.492868200 -0700
@@ -74,6 +74,10 @@
     library_search_paths += [os.path.dirname(library_search_paths[-1])]
     library_search_paths += [os.path.dirname(library_search_paths[-1])]
 
+    # Filter unique search paths and those that are not part of system directories
+    library_search_paths = list(filter(lambda x: x not in SYSTEM_LIBRARY_DIRECTORIES,
+                                       set(library_search_paths)))
+
     # Search for the core library in the search paths
     libraries = []
     for search_path in library_search_paths:
@@ -82,6 +86,7 @@
     # Search system library directories (too slow for recursive search)
     for search_path in SYSTEM_LIBRARY_DIRECTORIES:
         libraries += glob.glob("%s/**/*.%s*" % (search_path, LIBRARY_EXTENSION), recursive=False)
+        libraries += glob.glob("%s/*.%s*" % (search_path, LIBRARY_EXTENSION), recursive=False)
 
     del search_path, library_search_paths
 
@@ -343,7 +348,8 @@
         for linked_lib_include_dir in extract_library_include_dirs(library, prefix):
             if linked_lib_include_dir not in known_include_dirs:
                 known_include_dirs.add(linked_lib_include_dir)
-                cppyy.add_include_path(linked_lib_include_dir)
+                if os.path.isdir(linked_lib_include_dir):
+                    cppyy.add_include_path(linked_lib_include_dir)
 
     for module in modules:
         cppyy.include("ns3/%s-module.h" % module)
@@ -390,17 +396,6 @@
 
     cppyy.gbl.ns3.Node.__del__ = Node_del
 
-    # Define ns.cppyy.gbl.addressFromIpv4Address and others
-    cppyy.cppdef("""using namespace ns3;
-                    Address addressFromIpv4Address(Ipv4Address ip){ return Address(ip); };
-                    Address addressFromInetSocketAddress(InetSocketAddress addr){ return Address(addr); };
-                    Address addressFromPacketSocketAddress(PacketSocketAddress addr){ return Address(addr); };
-                    """)
-    # Expose addressFromIpv4Address as a member of the ns3 namespace (equivalent to ns)
-    setattr(cppyy.gbl.ns3, "addressFromIpv4Address", cppyy.gbl.addressFromIpv4Address)
-    setattr(cppyy.gbl.ns3, "addressFromInetSocketAddress", cppyy.gbl.addressFromInetSocketAddress)
-    setattr(cppyy.gbl.ns3, "addressFromPacketSocketAddress", cppyy.gbl.addressFromPacketSocketAddress)
-
     cppyy.cppdef("""
         using namespace ns3;
         std::tuple<bool, TypeId> LookupByNameFailSafe(std::string name)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/3rd-party/colored-messages.cmake ns-3.38/build-support/3rd-party/colored-messages.cmake
--- ns-3.37/build-support/3rd-party/colored-messages.cmake	2022-11-01 17:37:24.367394700 -0700
+++ ns-3.38/build-support/3rd-party/colored-messages.cmake	2023-03-16 20:54:23.492868200 -0700
@@ -71,25 +71,25 @@
   # Replace the default message macro with a custom colored one
   function(message)
     list(GET ARGV 0 MessageType)
+    list(REMOVE_AT ARGV 0)
+
+    # Transform list of arguments into a single line.
+    string(REPLACE ";" " " ARGV "${ARGV}")
+
     if((${MessageType} STREQUAL FATAL_ERROR) OR (${MessageType} STREQUAL
                                                  SEND_ERROR)
     )
-      list(REMOVE_AT ARGV 0)
       _message(${MessageType} "${BoldRed}${ARGV}${ColourReset}")
     elseif(MessageType STREQUAL WARNING)
-      list(REMOVE_AT ARGV 0)
       _message(${MessageType} "${Yellow}${ARGV}${ColourReset}")
     elseif(MessageType STREQUAL AUTHOR_WARNING)
-      list(REMOVE_AT ARGV 0)
       _message(${MessageType} "${BoldCyan}${ARGV}${ColourReset}")
     elseif(MessageType STREQUAL HIGHLIGHTED_STATUS) # Custom message type
-      list(REMOVE_AT ARGV 0)
       _message(STATUS "${Yellow}${ARGV}${ColourReset}")
     elseif(MessageType STREQUAL STATUS)
-      list(REMOVE_AT ARGV 0)
       _message(${MessageType} "${ARGV}")
     else()
-      _message(${ARGV})
+      _message(${MessageType} "${ARGV}")
     endif()
   endfunction()
 endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/3rd-party/FindEigen3.cmake ns-3.38/build-support/3rd-party/FindEigen3.cmake
--- ns-3.37/build-support/3rd-party/FindEigen3.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/build-support/3rd-party/FindEigen3.cmake	2023-03-16 20:54:23.492868200 -0700
@@ -0,0 +1,109 @@
+# cmake-format: off
+# - Try to find Eigen3 lib
+#
+# This module supports requiring a minimum version, e.g. you can do
+#   find_package(Eigen3 3.1.2)
+# to require version 3.1.2 or newer of Eigen3.
+#
+# Once done this will define
+#
+#  EIGEN3_FOUND - system has eigen lib with correct version
+#  EIGEN3_INCLUDE_DIR - the eigen include directory
+#  EIGEN3_VERSION - eigen version
+#
+# and the following imported target:
+#
+#  Eigen3::Eigen - The header-only Eigen library
+#
+# This module reads hints about search locations from
+# the following environment variables:
+#
+# EIGEN3_ROOT
+# EIGEN3_ROOT_DIR
+
+# Copyright (c) 2006, 2007 Montel Laurent, <montel@kde.org>
+# Copyright (c) 2008, 2009 Gael Guennebaud, <g.gael@free.fr>
+# Copyright (c) 2009 Benoit Jacob <jacob.benoit.1@gmail.com>
+# Redistribution and use is allowed according to the terms of the 2-clause BSD license.
+
+if(NOT Eigen3_FIND_VERSION)
+  if(NOT Eigen3_FIND_VERSION_MAJOR)
+    set(Eigen3_FIND_VERSION_MAJOR 2)
+  endif()
+  if(NOT Eigen3_FIND_VERSION_MINOR)
+    set(Eigen3_FIND_VERSION_MINOR 91)
+  endif()
+  if(NOT Eigen3_FIND_VERSION_PATCH)
+    set(Eigen3_FIND_VERSION_PATCH 0)
+  endif()
+
+  set(Eigen3_FIND_VERSION "${Eigen3_FIND_VERSION_MAJOR}.${Eigen3_FIND_VERSION_MINOR}.${Eigen3_FIND_VERSION_PATCH}")
+endif()
+
+macro(_eigen3_check_version)
+  file(READ "${EIGEN3_INCLUDE_DIR}/Eigen/src/Core/util/Macros.h" _eigen3_version_header)
+
+  string(REGEX MATCH "define[ \t]+EIGEN_WORLD_VERSION[ \t]+([0-9]+)" _eigen3_world_version_match "${_eigen3_version_header}")
+  set(EIGEN3_WORLD_VERSION "${CMAKE_MATCH_1}")
+  string(REGEX MATCH "define[ \t]+EIGEN_MAJOR_VERSION[ \t]+([0-9]+)" _eigen3_major_version_match "${_eigen3_version_header}")
+  set(EIGEN3_MAJOR_VERSION "${CMAKE_MATCH_1}")
+  string(REGEX MATCH "define[ \t]+EIGEN_MINOR_VERSION[ \t]+([0-9]+)" _eigen3_minor_version_match "${_eigen3_version_header}")
+  set(EIGEN3_MINOR_VERSION "${CMAKE_MATCH_1}")
+
+  set(EIGEN3_VERSION ${EIGEN3_WORLD_VERSION}.${EIGEN3_MAJOR_VERSION}.${EIGEN3_MINOR_VERSION})
+  if(${EIGEN3_VERSION} VERSION_LESS ${Eigen3_FIND_VERSION})
+    set(EIGEN3_VERSION_OK FALSE)
+  else()
+    set(EIGEN3_VERSION_OK TRUE)
+  endif()
+
+  if(NOT EIGEN3_VERSION_OK)
+
+    message(STATUS "Eigen3 version ${EIGEN3_VERSION} found in ${EIGEN3_INCLUDE_DIR}, "
+                   "but at least version ${Eigen3_FIND_VERSION} is required")
+  endif()
+endmacro()
+
+if (EIGEN3_INCLUDE_DIR)
+
+  # in cache already
+  _eigen3_check_version()
+  set(EIGEN3_FOUND ${EIGEN3_VERSION_OK})
+  set(Eigen3_FOUND ${EIGEN3_VERSION_OK})
+
+else ()
+
+  # search first if an Eigen3Config.cmake is available in the system,
+  # if successful this would set EIGEN3_INCLUDE_DIR and the rest of
+  # the script will work as usual
+  find_package(Eigen3 ${Eigen3_FIND_VERSION} NO_MODULE QUIET)
+
+  if(NOT EIGEN3_INCLUDE_DIR)
+    find_path(EIGEN3_INCLUDE_DIR NAMES signature_of_eigen3_matrix_library
+        HINTS
+        ENV EIGEN3_ROOT
+        ENV EIGEN3_ROOT_DIR
+        PATHS
+        ${CMAKE_INSTALL_PREFIX}/include
+        ${KDE4_INCLUDE_DIR}
+        PATH_SUFFIXES eigen3 eigen
+      )
+  endif()
+
+  if(EIGEN3_INCLUDE_DIR)
+    _eigen3_check_version()
+  endif()
+
+  include(FindPackageHandleStandardArgs)
+  find_package_handle_standard_args(Eigen3 DEFAULT_MSG EIGEN3_INCLUDE_DIR EIGEN3_VERSION_OK)
+
+  mark_as_advanced(EIGEN3_INCLUDE_DIR)
+
+endif()
+
+if(EIGEN3_FOUND AND NOT TARGET Eigen3::Eigen)
+  add_library(Eigen3::Eigen INTERFACE IMPORTED)
+  set_target_properties(Eigen3::Eigen PROPERTIES
+    INTERFACE_INCLUDE_DIRECTORIES "${EIGEN3_INCLUDE_DIR}")
+endif()
+# cmake-format: on
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/3rd-party/find-program-hints.cmake ns-3.38/build-support/3rd-party/find-program-hints.cmake
--- ns-3.37/build-support/3rd-party/find-program-hints.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/build-support/3rd-party/find-program-hints.cmake	2023-03-16 20:54:23.492868200 -0700
@@ -0,0 +1,20 @@
+set(3RD_PARTY_FIND_PROGRAM_HINTS
+    # find_program HINTS for Doxygen
+    # https://gitlab.kitware.com/cmake/cmake/-/blob/master/Modules/FindDoxygen.cmake
+    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\doxygen_is1;Inno Setup: App Path]/bin"
+    /Applications/Doxygen.app/Contents/Resources
+    /Applications/Doxygen.app/Contents/MacOS
+    /Applications/Utilities/Doxygen.app/Contents/Resources
+    /Applications/Utilities/Doxygen.app/Contents/MacOS
+    # find_program HINTS for Dia
+    # https://gitlab.kitware.com/cmake/cmake/-/blob/master/Modules/FindDoxygen.cmake
+    "$ENV{ProgramFiles}/Dia"
+    "$ENV{ProgramFiles\(x86\)}/Dia"
+    # find_program HINTS for Graphviz
+    # https://gitlab.kitware.com/cmake/cmake/-/blob/master/Modules/FindDoxygen.cmake
+    "$ENV{ProgramFiles}/ATT/Graphviz/bin"
+    "C:/Program Files/ATT/Graphviz/bin"
+    "[HKEY_LOCAL_MACHINE\\SOFTWARE\\ATT\\Graphviz;InstallPath]/bin"
+    /Applications/Graphviz.app/Contents/MacOS
+    /Applications/Utilities/Graphviz.app/Contents/MacOS
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/compiler-workarounds/ostream-operator-nullptr.h ns-3.38/build-support/compiler-workarounds/ostream-operator-nullptr.h
--- ns-3.37/build-support/compiler-workarounds/ostream-operator-nullptr.h	2022-11-01 17:37:24.367394700 -0700
+++ ns-3.38/build-support/compiler-workarounds/ostream-operator-nullptr.h	2023-03-16 20:54:23.492868200 -0700
@@ -7,7 +7,7 @@
 namespace std
 {
 inline std::ostream&
-operator<<(std::ostream& os, std::nullptr_t ptr)
+operator<<(std::ostream& os, std::nullptr_t)
 {
     return os << "nullptr"; // whatever you want nullptr to show up as in the console
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/custom-modules/ns3-configtable.cmake ns-3.38/build-support/custom-modules/ns3-configtable.cmake
--- ns-3.37/build-support/custom-modules/ns3-configtable.cmake	2022-11-01 17:37:24.367394700 -0700
+++ ns-3.38/build-support/custom-modules/ns3-configtable.cmake	2023-03-16 20:54:23.492868200 -0700
@@ -113,12 +113,18 @@
 endfunction()
 
 macro(write_configtable)
-  set(out "---- Summary of optional ns-3 features:\n")
+  set(out "---- Summary of ns-3 settings:\n")
   string(APPEND out "Build profile                 : ${build_profile}\n")
   string(APPEND out
          "Build directory               : ${CMAKE_OUTPUT_DIRECTORY}\n"
   )
 
+  string(APPEND out "Build with runtime asserts    : ")
+  check_on_or_off("${NS3_ASSERT}" "${NS3_ASSERT}")
+
+  string(APPEND out "Build with runtime logging    : ")
+  check_on_or_off("${NS3_LOG}" "${NS3_LOG}")
+
   string(APPEND out "Build version embedding       : ")
   check_on_or_off("${NS3_ENABLE_BUILD_VERSION}" "${ENABLE_BUILD_VERSION}")
 
@@ -170,6 +176,9 @@
   string(APPEND out "SQLite support                : ")
   check_on_or_off("${NS3_SQLITE}" "${ENABLE_SQLITE}")
 
+  string(APPEND out "Eigen3 support                : ")
+  check_on_or_off("${NS3_EIGEN}" "${ENABLE_EIGEN}")
+
   string(APPEND out "Tap Bridge                    : ")
   check_on_or_off("${ENABLE_TAP}" "${ENABLE_TAP}")
 
@@ -211,4 +220,8 @@
 
   file(WRITE ${PROJECT_BINARY_DIR}/ns3config.txt ${out})
   message(STATUS ${out})
+
+  if(NOT (${NS3RC} STREQUAL "NS3RC-NOTFOUND"))
+    message(STATUS "Applying configuration override from: ${NS3RC}")
+  endif()
 endmacro()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake ns-3.38/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake
--- ns-3.37/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/build-support/custom-modules/ns3-fetch-optional-modules-dependencies.cmake	2023-03-16 20:54:23.492868200 -0700
@@ -0,0 +1,75 @@
+include(ExternalProject)
+
+ExternalProject_Add(
+  brite_dep
+  URL https://code.nsnam.org/BRITE/archive/30338f4f63b9.zip
+  URL_HASH MD5=b36ecf8f6b5f2cfae936ba1f1bfcff5c
+  PREFIX brite_dep
+  BUILD_IN_SOURCE TRUE
+  CONFIGURE_COMMAND make
+  BUILD_COMMAND make
+  INSTALL_COMMAND make install PREFIX=${CMAKE_OUTPUT_DIRECTORY}
+)
+
+ExternalProject_Add(
+  click_dep
+  GIT_REPOSITORY https://github.com/kohler/click.git
+  GIT_TAG 9197a594b1c314264935106297aff08d97cbe7ee
+  PREFIX click_dep
+  BUILD_IN_SOURCE TRUE
+  UPDATE_DISCONNECTED TRUE
+  CONFIGURE_COMMAND ./configure --disable-linuxmodule --enable-nsclick
+                    --enable-wifi --prefix ${CMAKE_OUTPUT_DIRECTORY}
+  BUILD_COMMAND make -j${NumThreads}
+  INSTALL_COMMAND make install
+)
+
+ExternalProject_Add(
+  openflow_dep
+  URL https://code.nsnam.org/openflow/archive/d45e7d184151.zip
+  URL_HASH MD5=a068cdaec5523586921b2f1f81f10916
+  PREFIX openflow_dep
+  BUILD_IN_SOURCE TRUE
+  CONFIGURE_COMMAND ./waf configure --prefix ${CMAKE_OUTPUT_DIRECTORY}
+  BUILD_COMMAND ./waf build
+  INSTALL_COMMAND ./waf install
+)
+
+install(
+  DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/include/openflow
+  DESTINATION ${CMAKE_INSTALL_PREFIX}/include
+  USE_SOURCE_PERMISSIONS
+  PATTERN "openflow/*"
+)
+
+find_file(
+  BOOST_STATIC_ASSERT
+  NAMES static_assert.hpp
+  PATH_SUFFIXES boost
+  HINTS /usr/local
+)
+get_filename_component(boost_dir ${BOOST_STATIC_ASSERT} DIRECTORY)
+
+install(
+  DIRECTORY ${boost_dir}
+  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
+  USE_SOURCE_PERMISSIONS
+  PATTERN "boost/*"
+)
+install(
+  DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/lib/
+  DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  USE_SOURCE_PERMISSIONS
+  PATTERN "lib/*"
+)
+
+macro(add_dependency_to_optional_modules_dependencies)
+  add_dependencies(${libbrite} brite_dep)
+  add_dependencies(${libclick} click_dep)
+  add_dependencies(${libopenflow} openflow_dep)
+  if(NOT ${XCODE})
+    add_dependencies(${libbrite}-obj brite_dep)
+    add_dependencies(${libclick}-obj click_dep)
+    add_dependencies(${libopenflow}-obj openflow_dep)
+  endif()
+endmacro()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/custom-modules/ns3-module-macros.cmake ns-3.38/build-support/custom-modules/ns3-module-macros.cmake
--- ns-3.37/build-support/custom-modules/ns3-module-macros.cmake	2022-11-01 17:37:24.367394700 -0700
+++ ns-3.38/build-support/custom-modules/ns3-module-macros.cmake	2023-03-16 20:54:23.492868200 -0700
@@ -125,7 +125,8 @@
     ${lib${BLIB_LIBNAME}}
     PROPERTIES
       PUBLIC_HEADER
-      "${BLIB_HEADER_FILES};${BLIB_DEPRECATED_HEADER_FILES};${config_headers};${BLIB_PRIVATE_HEADER_FILES};${CMAKE_HEADER_OUTPUT_DIRECTORY}/${BLIB_LIBNAME}-module.h"
+      "${BLIB_HEADER_FILES};${BLIB_DEPRECATED_HEADER_FILES};${config_headers};${CMAKE_HEADER_OUTPUT_DIRECTORY}/${BLIB_LIBNAME}-module.h"
+      PRIVATE_HEADER "${BLIB_PRIVATE_HEADER_FILES}"
       RUNTIME_OUTPUT_DIRECTORY ${CMAKE_LIBRARY_OUTPUT_DIRECTORY} # set output
                                                                  # directory for
                                                                  # DLLs
@@ -225,11 +226,35 @@
   # Write a module header that includes all headers from that module
   write_module_header("${BLIB_LIBNAME}" "${BLIB_HEADER_FILES}")
 
+  # Check if headers actually exist to prevent copying errors during
+  # installation
+  get_target_property(headers_to_check ${lib${BLIB_LIBNAME}} PUBLIC_HEADER)
+  set(missing_headers)
+  foreach(header ${headers_to_check})
+    if(NOT ((EXISTS ${header}) OR (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${header})
+           )
+    )
+      list(APPEND missing_headers ${header})
+    endif()
+  endforeach()
+  if(missing_headers)
+    message(
+      FATAL_ERROR "Missing header files for ${BLIB_LIBNAME}: ${missing_headers}"
+    )
+  endif()
+
   # Copy all header files to outputfolder/include before each build
   copy_headers_before_building_lib(
-    ${BLIB_LIBNAME} ${CMAKE_HEADER_OUTPUT_DIRECTORY}
-    "${BLIB_HEADER_FILES};${BLIB_PRIVATE_HEADER_FILES}" public
+    ${BLIB_LIBNAME} ${CMAKE_HEADER_OUTPUT_DIRECTORY} "${BLIB_HEADER_FILES}"
+    public
   )
+  if(BLIB_PRIVATE_HEADER_FILES)
+    copy_headers_before_building_lib(
+      ${BLIB_LIBNAME} ${CMAKE_HEADER_OUTPUT_DIRECTORY}
+      "${BLIB_PRIVATE_HEADER_FILES}" private
+    )
+  endif()
+
   if(BLIB_DEPRECATED_HEADER_FILES)
     copy_headers_before_building_lib(
       ${BLIB_LIBNAME} ${CMAKE_HEADER_OUTPUT_DIRECTORY}
@@ -337,6 +362,7 @@
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/
     RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/
     PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ns3"
+    PRIVATE_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ns3"
   )
   if(${NS3_VERBOSE})
     message(STATUS "Processed ${FOLDER}")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/build-support/empty-main.cc ns-3.38/build-support/empty-main.cc
--- ns-3.37/build-support/empty-main.cc	2022-11-01 17:37:24.371394600 -0700
+++ ns-3.38/build-support/empty-main.cc	2023-03-16 20:54:23.492868200 -0700
@@ -1,4 +1,5 @@
 int
 main()
 {
+    return 0;
 }
